---
# Service
apiVersion: v1
kind: Service
metadata:
  name: ${CI_PROJECT_NAME}
  # this annotation is mandatory
  annotations:
    prometheus.io/scrape: 'true'
  # These labels are mandatory
  labels:
    application: ${CI_ENVIRONMENT_SLUG}
    release: ${CI_ENVIRONMENT_SLUG}
spec:
  selector:
    app: ${CI_PROJECT_NAME}
  ports:
    - port: ${EXPOSED_PORT}
      targetPort: ${CONTAINER_PORT}
---
# Deployment
apiVersion: apps/v1
kind: Deployment
metadata:
  name: ${CI_PROJECT_NAME}
  annotations:
    app.gitlab.com/app: ${CI_PROJECT_PATH_SLUG}
    app.gitlab.com/env: ${CI_ENVIRONMENT_SLUG}
spec:
  replicas: 1
  selector:
    matchLabels:
      app: ${CI_PROJECT_NAME}
  template:
    metadata:
      labels:
        app: ${CI_PROJECT_NAME}
      annotations:
        app.gitlab.com/app: ${CI_PROJECT_PATH_SLUG}
        app.gitlab.com/env: ${CI_ENVIRONMENT_SLUG}
    spec:
      containers:
        - name: ${CI_PROJECT_NAME}
          image: ${CI_REGISTRY_IMAGE}:${CI_COMMIT_SHORT_SHA}
          ports:
            - containerPort: ${CONTAINER_PORT}
          imagePullPolicy: Always
---
# Ingress
apiVersion: extensions/v1beta1
kind: Ingress
metadata:
  name: ${CI_PROJECT_NAME}
spec:
  rules:
    - host: ${CI_PROJECT_NAME}.${CI_COMMIT_REF_SLUG}.${KUBE_INGRESS_BASE_DOMAIN}
      http:
        paths:
          - backend:
              serviceName: ${CI_PROJECT_NAME}
              servicePort: ${EXPOSED_PORT}


